#!/bin/sh
append DRIVERS "atheros"
+find_atheros_phy() {
+ local device="$1"
+
+ local macaddr="$(config_get "$device" macaddr | tr 'A-Z' 'a-z')"
+ config_get phy "$device" phy
+ [ -z "$phy" -a -n "$macaddr" ] && {
+ cd /proc/sys/dev
+ for phy in $(ls -d wifi* 2>&-); do
+ [ "$macaddr" = "$(cat /sys/class/net/${phy}/address)" ] || continue
+ config_set "$device" phy "$phy"
+ break
+ done
+ config_get phy "$device" phy
+ }
+ [ -n "$phy" -a -d "/proc/sys/dev/$phy" ] || {
+ echo "phy for wifi device $1 not found"
+ return 1
+ }
+ [ -z "$macaddr" ] && {
+ config_set "$device" macaddr "$(cat /sys/class/net/${phy}/address)"
+ }
+ return 0
+}
+
scan_atheros() {
local device="$1"
local wds
- local adhoc sta ap
+ local adhoc ahdemo sta ap monitor disabled
+
+ [ ${device%[0-9]} = "wifi" ] && config_set "$device" phy "$device"
+
+ local ifidx=0
config_get vifs "$device" vifs
for vif in $vifs; do
-
+ config_get_bool disabled "$vif" disabled 0
+ [ $disabled = 0 ] || continue
+
+ local vifname
+ [ $ifidx -gt 0 ] && vifname="ath${device#radio}-$ifidx" || vifname="ath${device#radio}"
+
config_get ifname "$vif" ifname
- config_set "$vif" ifname "${ifname:-ath}"
+ config_set "$vif" ifname "${ifname:-$vifname}"
config_get mode "$vif" mode
case "$mode" in
- adhoc|ahdemo|sta|ap)
+ adhoc|ahdemo|sta|ap|monitor)
append $mode "$vif"
;;
wds)
- config_get addr "$vif" bssid
config_get ssid "$vif" ssid
- [ -z "$addr" -a -n "$ssid" ] && {
- config_set "$vif" wds 1
- config_set "$vif" mode sta
- mode="sta"
- addr="$ssid"
- }
+ [ -z "$ssid" ] && continue
+
+ config_set "$vif" wds 1
+ config_set "$vif" mode sta
+ mode="sta"
+ addr="$ssid"
${addr:+append $mode "$vif"}
;;
*) echo "$device($vif): Invalid mode, ignored."; continue;;
esac
+
+ ifidx=$(($ifidx + 1))
done
- case "${adhoc:+1}:${sta:+1}:${ap+1}" in
+ case "${adhoc:+1}:${sta:+1}:${ap:+1}" in
# valid mode combinations
1::) wds="";;
1::1);;
*) echo "$device: Invalid mode combination in config"; return 1;;
esac
- config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
+ config_set "$device" vifs "${sta:+$sta }${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${wds:+$wds }${monitor:+$monitor}"
}
disable_atheros() (
local device="$1"
+ find_atheros_phy "$device" || return 0
+ config_get phy "$device" phy
+
set_wifi_down "$device"
- # kill all running hostapd and wpa_supplicant processes that
- # are running on atheros vifs
- for pid in `pidof hostapd wpa_supplicant`; do
- grep ath /proc/$pid/cmdline >/dev/null && \
- kill $pid
- done
-
+
include /lib/network
cd /proc/sys/net
for dev in *; do
- grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
- ifconfig "$dev" down
+ grep "$phy" "$dev/%parent" >/dev/null 2>/dev/null && {
+ [ -f "/var/run/wifi-${dev}.pid" ] &&
+ kill "$(cat "/var/run/wifi-${dev}.pid")"
+ ifconfig "$dev" down
unbridge "$dev"
wlanconfig "$dev" destroy
}
enable_atheros() {
local device="$1"
+
+ find_atheros_phy "$device" || return 0
+ config_get phy "$device" phy
+
+ config_get regdomain "$device" regdomain
+ [ -n "$regdomain" ] && echo "$regdomain" > /proc/sys/dev/$phy/regdomain
+
+ config_get country "$device" country
+ case "$country" in
+ [A-Za-z]*) country=`grep -i "$country" /lib/wifi/madwifi_countrycodes.txt |cut -d " " -f 2`;;
+ [0-9]*) ;;
+ *) country="" ;;
+ esac
+ [ -n "$country" ] && echo "$country" > /proc/sys/dev/$phy/countrycode
+
+ config_get_bool outdoor "$device" outdoor "0"
+ echo "$outdoor" > /proc/sys/dev/$phy/outdoor
+
config_get channel "$device" channel
config_get vifs "$device" vifs
-
- local first=1
+ config_get txpower "$device" txpower
+
+ [ auto = "$channel" ] && channel=0
+
+ config_get_bool antdiv "$device" diversity
+ config_get antrx "$device" rxantenna
+ config_get anttx "$device" txantenna
+ config_get_bool softled "$device" softled
+ config_get antenna "$device" antenna
+
+ devname="$(cat /proc/sys/dev/$phy/dev_name)"
+ local antgpio=
+ local invert=
+ case "$devname" in
+ NanoStation2) antgpio=7; invert=1;;
+ NanoStation5) antgpio=1; invert=1;;
+ "NanoStation Loco2") antgpio=2;;
+ "NanoStation Loco5")
+ case "$antenna" in
+ horizontal) antdiv=0; anttx=1; antrx=1;;
+ vertical) antdiv=0; anttx=2; antrx=2;;
+ *) antdiv=1; anttx=0; antrx=0;;
+ esac
+ ;;
+ esac
+ if [ -n "$invert" ]; then
+ _set="clear"
+ _clear="set"
+ else
+ _set="set"
+ _clear="clear"
+ fi
+ if [ -n "$antgpio" ]; then
+ softled=0
+ case "$devname" in
+ "NanoStation Loco2")
+ antdiv=0
+ antrx=1
+ anttx=1
+ case "$antenna" in
+ horizontal) gpioval=0;;
+ *) gpioval=1;;
+ esac
+ ;;
+ *)
+ case "$antenna" in
+ external) antdiv=0; antrx=1; anttx=1; gpioval=1;;
+ horizontal) antdiv=0; antrx=1; anttx=1; gpioval=0;;
+ vertical) antdiv=0; antrx=2; anttx=2; gpioval=0;;
+ auto) antdiv=1; antrx=0; anttx=0; gpioval=0;;
+ esac
+ ;;
+ esac
+
+ [ -x "$(which gpioctl 2>/dev/null)" ] || antenna=
+ gpioctl "dirout" "$antgpio" >/dev/null 2>&1
+ case "$gpioval" in
+ 0)
+ gpioctl "$_clear" "$antgpio" >/dev/null 2>&1
+ ;;
+ 1)
+ gpioctl "$_set" "$antgpio" >/dev/null 2>&1
+ ;;
+ esac
+ fi
+
+ [ -n "$antdiv" ] && sysctl -w dev."$phy".diversity="$antdiv" >&-
+ [ -n "$antrx" ] && sysctl -w dev."$phy".rxantenna="$antrx" >&-
+ [ -n "$anttx" ] && sysctl -w dev."$phy".txantenna="$anttx" >&-
+ [ -n "$softled" ] && sysctl -w dev."$phy".softled="$softled" >&-
+
+ config_get distance "$device" distance
+ [ -n "$distance" ] && sysctl -w dev."$phy".distance="$distance" >&-
+
for vif in $vifs; do
- nosbeacon=
+ local start_hostapd= vif_txpower= nosbeacon=
config_get ifname "$vif" ifname
config_get enc "$vif" encryption
+ config_get eap_type "$vif" eap_type
config_get mode "$vif" mode
-
- [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
-
- config_get ifname "$vif" ifname
- ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
+
+ case "$mode" in
+ sta) config_get_bool nosbeacon "$device" nosbeacon;;
+ adhoc) config_get_bool nosbeacon "$vif" sw_merge 1;;
+ esac
+
+ [ "$nosbeacon" = 1 ] || nosbeacon=""
+ ifname=$(wlanconfig "$ifname" create nounit wlandev "$phy" wlanmode "$mode" ${nosbeacon:+nosbeacon})
[ $? -ne 0 ] && {
echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
continue
}
config_set "$vif" ifname "$ifname"
- [ "$first" = 1 ] && {
- # only need to change freq band and channel on the first vif
- config_get agmode "$device" agmode
- pureg=0
- case "$agmode" in
- *b) agmode=11b;;
- *bg) agmode=11g;;
- *g) agmode=11g; pureg=1;;
- *a) agmode=11a;;
- *) agmode=auto;;
- esac
- iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
- ifconfig "$ifname" up
- sleep 1
- iwpriv "$ifname" mode "$agmode"
- iwpriv "$ifname" pureg "$pureg"
- iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
- }
-
+ config_get hwmode "$device" hwmode
+ [ -z "$hwmode" ] && config_get hwmode "$device" mode
+
+ pureg=0
+ case "$hwmode" in
+ *b) hwmode=11b;;
+ *bg) hwmode=11g;;
+ *g) hwmode=11g; pureg=1;;
+ *gdt) hwmode=11gdt;;
+ *a) hwmode=11a;;
+ *adt) hwmode=11adt;;
+ *ast) hwmode=11ast;;
+ *fh) hwmode=fh;;
+ *) hwmode=auto;;
+ esac
+ iwpriv "$ifname" mode "$hwmode"
+ iwpriv "$ifname" pureg "$pureg"
+
+ iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
+
config_get_bool hidden "$vif" hidden 0
iwpriv "$ifname" hide_ssid "$hidden"
1|on|enabled) wds=1;;
*) wds=0;;
esac
- iwpriv "$ifname" wds "$wds"
+ iwpriv "$ifname" wds "$wds" >/dev/null 2>&1
+
+ [ "$mode" = ap -a "$wds" = 1 ] && {
+ config_get_bool wdssep "$vif" wdssep 1
+ [ -n "$wdssep" ] && iwpriv "$ifname" wdssep "$wdssep"
+ }
- wpa=
case "$enc" in
- WEP|wep)
+ wep*)
+ case "$enc" in
+ *shared*) iwpriv "$ifname" authmode 2;;
+ *) iwpriv "$ifname" authmode 1;;
+ esac
for idx in 1 2 3 4; do
config_get key "$vif" "key${idx}"
iwconfig "$ifname" enc "[$idx]" "${key:-off}"
*) iwconfig "$ifname" enc "$key";;
esac
;;
- PSK|psk|PSK2|psk2)
+ psk*|wpa*)
+ start_hostapd=1
config_get key "$vif" key
;;
esac
case "$mode" in
- wds)
- config_get addr "$vif" bssid
- iwpriv "$ifname" wds_add "$addr"
- ;;
- adhoc|ahdemo)
+ sta|adhoc|ahdemo)
config_get addr "$vif" bssid
[ -z "$addr" ] || {
iwconfig "$ifname" ap "$addr"
}
;;
esac
- config_get ssid "$vif" ssid
+
+ config_get_bool uapsd "$vif" uapsd 0
+ iwpriv "$ifname" uapsd "$uapsd"
config_get_bool bgscan "$vif" bgscan
[ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
- config_get_bool antdiv "$device" diversity
- [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
-
- config_get antrx "$device" rxantenna
- [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
-
- config_get anttx "$device" txantenna
- [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
-
- config_get distance "$device" distance
- [ -n "$distance" ] && athctrl -i "$device" -d "$distance" >&-
-
- config_get txpwr "$vif" txpower
- [ -n "$txpwr" ] && iwconfig "$ifname" txpower "${txpwr%%.*}"
-
config_get rate "$vif" rate
[ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
config_get rts "$vif" rts
[ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
- config_get_bool doth "$vif" 80211h
- [ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
+ config_get_bool comp "$vif" compression 0
+ iwpriv "$ifname" compression "$comp" >/dev/null 2>&1
+
+ config_get minrate "$vif" minrate
+ [ -n "$minrate" ] && iwpriv "$ifname" minrate "$minrate"
- config_get_bool comp "$vif" compression
- [ -n "$comp" ] && iwpriv "$ifname" compression "$comp"
+ config_get maxrate "$vif" maxrate
+ [ -n "$maxrate" ] && iwpriv "$ifname" maxrate "$maxrate"
config_get_bool burst "$vif" bursting
[ -n "$burst" ] && iwpriv "$ifname" burst "$burst"
config_get_bool ar "$vif" ar
[ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
- config_get_bool turbo "$vif" turbo
- [ -n "$turbo" ] && iwpriv "$ifname" turbo "$turbo"
+ config_get_bool beacon_power "$vif" beacon_power
+ [ -n "$beacon_power" ] && iwpriv "$ifname" beacon_pwr "$beacon_power"
+
+ config_get_bool doth "$vif" doth 0
+ [ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
+
+ config_get_bool probereq "$vif" probereq
+ [ -n "$probereq" ] && iwpriv "$ifname" probereq "$probereq"
config_get maclist "$vif" maclist
[ -n "$maclist" ] && {
esac
ifconfig "$ifname" up
- iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
local net_cfg bridge
net_cfg="$(find_net_config "$vif")"
config_set "$vif" bridge "$bridge"
start_net "$ifname" "$net_cfg"
}
- iwconfig "$ifname" essid "$ssid"
+
+ config_get ssid "$vif" ssid
+ [ -n "$ssid" ] && {
+ iwconfig "$ifname" essid on
+ iwconfig "$ifname" essid ${ssid:+-- }"$ssid"
+ }
+
set_wifi_up "$vif" "$ifname"
+
+ # TXPower settings only work if device is up already
+ # while atheros hardware theoretically is capable of per-vif (even per-packet) txpower
+ # adjustment it does not work with the current atheros hal/madwifi driver
+
+ config_get vif_txpower "$vif" txpower
+ # use vif_txpower (from wifi-iface) instead of txpower (from wifi-device) if
+ # the latter doesn't exist
+ txpower="${txpower:-$vif_txpower}"
+ [ -z "$txpower" ] || iwconfig "$ifname" txpower "${txpower%%.*}"
+
case "$mode" in
ap)
config_get_bool isolate "$vif" isolate 0
iwpriv "$ifname" ap_bridge "$((isolate^1))"
- if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
+ if [ -n "$start_hostapd" ] && eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
hostapd_setup_vif "$vif" madwifi || {
- echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
+ echo "enable_atheros($device): Failed to set up hostapd for interface $ifname" >&2
# make sure this wifi interface won't accidentally stay open without encryption
ifconfig "$ifname" down
wlanconfig "$ifname" destroy
fi
;;
wds|sta)
- case "$enc" in
- PSK|psk|PSK2|psk2)
- case "$enc" in
- PSK|psk)
- proto='proto=WPA'
- passphrase="${key}"
- ;;
- PSK2|psk2)
- proto='proto=RSN'
- passphrase=`wpa_passphrase ${ssid} "${key}" | grep psk | grep -v \#| cut -d= -f2`
- ;;
- esac
-
- cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
-ctrl_interface=/var/run/wpa_supplicant
-network={
- scan_ssid=1
- ssid="$ssid"
- key_mgmt=WPA-PSK
- $proto
- psk="$passphrase"
-}
-EOF
- ;;
- WPA|wpa|WPA2|wpa2)
- #add wpa_supplicant calls here
- ;;
- esac
- [ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -B -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
+ if eval "type wpa_supplicant_setup_vif" 2>/dev/null >/dev/null; then
+ wpa_supplicant_setup_vif "$vif" wext || {
+ echo "enable_atheros($device): Failed to set up wpa_supplicant for interface $ifname" >&2
+ ifconfig "$ifname" down
+ wlanconfig "$ifname" destroy
+ continue
+ }
+ fi
;;
+ adhoc)
+ if eval "type wpa_supplicant_setup_vif" 2>/dev/null >/dev/null; then
+ wpa_supplicant_setup_vif "$vif" madwifi || {
+ echo "enable_atheros($device): Failed to set up wpa"
+ ifconfig "$ifname" down
+ wlanconfig "$ifname" destroy
+ continue
+ }
+ fi
esac
- first=0
done
}
+check_atheros_device() {
+ [ ${1%[0-9]} = "wifi" ] && config_set "$1" phy "$1"
+ config_get phy "$1" phy
+ [ -z "$phy" ] && {
+ find_atheros_phy "$1" >/dev/null || return 0
+ config_get phy "$1" phy
+ }
+ [ "$phy" = "$dev" ] && found=1
+}
+
detect_atheros() {
+ devidx=0
+ config_load wireless
+ while :; do
+ config_get type "radio$devidx" type
+ [ -n "$type" ] || break
+ devidx=$(($devidx + 1))
+ done
cd /proc/sys/dev
[ -d ath ] || return
for dev in $(ls -d wifi* 2>&-); do
- config_get type "$dev" type
- [ "$type" = atheros ] && return
+ found=0
+ config_foreach check_atheros_device wifi-device
+ [ "$found" -gt 0 ] && continue
+
+ devname="$(cat /proc/sys/dev/$dev/dev_name)"
+ case "$devname" in
+ "NanoStation Loco2")
+ EXTRA_DEV="
+# Ubiquiti NanoStation Loco2 features
+ option antenna vertical # (horizontal|vertical)
+"
+ ;;
+ "NanoStation Loco5")
+ EXTRA_DEV="
+# Ubiquiti NanoStation Loco5 features
+ option antenna auto # (auto|horizontal|vertical)
+"
+ ;;
+ NanoStation*)
+ EXTRA_DEV="
+# Ubiquiti NanoStation features
+ option antenna auto # (auto|horizontal|vertical|external)
+"
+ ;;
+ esac
+
cat <<EOF
-config wifi-device $dev
+config wifi-device radio$devidx
option type atheros
- option channel 5
-
+ option channel auto
+ option macaddr $(cat /sys/class/net/${dev}/address)
+$EXTRA_DEV
# REMOVE THIS LINE TO ENABLE WIFI:
option disabled 1
config wifi-iface
- option device $dev
+ option device radio$devidx
option network lan
option mode ap
option ssid OpenWrt
option encryption none
+
EOF
+ devidx=$(($devidx + 1))
done
}